package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.CaseProcessBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class CaseProcessModelImpl implements ICaseProcessModel {

    private OnGetCaseProcessListener listener;

    public CaseProcessModelImpl(OnGetCaseProcessListener processListener) {
        this.listener = processListener;
    }

    public interface OnGetCaseProcessListener {
        void onSuccess(CaseProcessBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest(String processId) {
        Observable<CaseProcessBean> observable = RetrofitServiceManager.getCaseProcessResult(processId);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<CaseProcessBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(CaseProcessBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}
